<?php
/**
 * @file
 * TogMine drush command to execute TogMine for all valid accounts.
 */


/**
 * Implementation of hook_drush_command().
 */
function togmine_drush_command() {
  $items = array();

  // The key in the $items array is the name of the command.
  $items['togmine-synchronize'] = array(
    'description' => 'Synchronizes Toggl.com time entries to Redmine.',
    'drupal dependencies' => array('togmine'),
  );

  return $items;
}

/**
 * Implementation of hook_drush_help().
 */
function togmine_drush_help($section) {
  switch ($section) {
    case 'meta:togmine:title': {
      return dt('TogMine commands');
    }
    case 'meta:togmine:summary': {
      return dt('@TODO Where does this help string appear?');
    }
  }
}

/**
 * A drush command callback.
 */
function drush_togmine_synchronize() {
  $result = togmine_synchronize();

  // Save the result object for later use.
  variable_set('togmine_latest_result', $result);

  // Log the message to watchdog, which also outputs on the command line.
  // Drush prints watchdog messages to screen too.
  watchdog('togmine', $result->message, array(), !$result->success ? WATCHDOG_ERROR : ($result->warning ? WATCHDOG_WARNING : WATCHDOG_INFO));

  if (togmine_var('debug')) {
    // Log more detail in debug mode.
    // Don't repeat the message.
    unset($result->message);
    watchdog('togmine', '<pre>' . var_export($result, TRUE) . '</pre>', array(), WATCHDOG_DEBUG);
    // rest_api_query_var_export($result, 'TogMine Result');
  }
}
